//   - "".
//       "-"
//       .
unit AutomataUnit;
interface
uses SysUtils, ExtCtrls, StdCtrls, Graphics;
type
  TState = class;

  //-  ""
  TApp = class(TObject)
  private
    states: array of TState;
    currentState: TState;
  public
    //   
    function GetRegisteredState(i: integer): TState;
    property CurrentAutomataState: TState read currentState;

    //  
    procedure SetState(stateIndex: integer);

    //  
    procedure RegisterState(state: TState);
    destructor Destroy; override;

    //  
    procedure ProcessSignal(signal: integer);
  end;

  // "-"
  TState = class(TObject)
  protected
    fX, fY: integer;  // ""  
    fIndex: integer;  //    -  
    fImage: TImage;   // ""
    fLabel: TLabel;   //  ""
    fOwner: TApp;
  public
    property Number: integer read fIndex; //   
    property Left: integer read fX; // X ""  
    property Top: integer read fY; // Y ""  

    procedure ProcessSignal(signal: integer); virtual; //  
    procedure Enter; virtual; //""  
    procedure Exit; virtual;  //""  

    constructor Create(app: TApp; x,y: integer);
    destructor Destroy; override;
  end;

implementation
uses MainUnit;
var
  StateIndex: integer = 1;



//  ---    App --- //

//    i
function TApp.GetRegisteredState(i: integer): TState;
begin
  result:=states[i-1];
end;

//      
procedure TApp.RegisterState(state: TState);
begin
  log(ltStateManagement,'   App    '
    +inttostr(state.Number));
  setLength(states,length(states)+1);
  States[high(states)]:=state;
  if length(states) = 1 then currentState:=state;
end;

//  -    
destructor TApp.Destroy;
var
  i: integer;
begin
  for i := 0 to high(states) do
    states[i].Free;
  setlength(states,0);
  inherited;
end;

//   -    
procedure TApp.ProcessSignal(signal: integer);
begin
  currentState.ProcessSignal(signal);
end;

//   
procedure TApp.SetState(stateIndex: integer);
begin
  //  ""   
  log(ltEnterExit,'  :');
  currentState.Exit;

  //  
  currentState:=states[stateIndex-1];
  log(ltStateChange,' App     '+inttostr(stateIndex));

  // ""   
  log(ltEnterExit,'  :');
  currentState.Enter;
end;


//  ---     State --- //

// 
destructor TState.Destroy;
begin
  log(ltStateManagement,'    '+inttostr(fIndex));
  inherited;
end;

// 
constructor TState.Create(app: TApp; x,y: integer);
begin
  fIndex:=StateIndex;
  inc(StateIndex);
  fX:=x;
  fY:=y;
  fOwner:=app;
  log(ltStateManagement,'    '+inttostr(fIndex));
  fImage:=TImage.Create(MainForm);
  fImage.AutoSize:=true;
  fImage.Picture.LoadFromFile('house.bmp');
  fImage.Transparent:=true;
  fImage.Parent:=MainForm.ViewPanel;
  fImage.Left:=fX-fImage.Width div 2;
  fImage.Top:=fY-fImage.Height div 2;
  fLabel:=TLabel.Create(MainForm);
  fLabel.Parent:=MainForm.ViewPanel;
  fLabel.Caption:=inttostr(fIndex);
  FLabel.Left:=fX+25;
  fLabel.Transparent:=true;
  FLabel.Top:=fY-30;
  fLabel.Font.Name:='Arial';
  fLabel.Font.Color:=clBlack;
  fLabel.Font.Size:=12;
end;

//  
procedure TState.ProcessSignal(signal: integer);
begin
  //   -   
end;

//""  
procedure TState.Enter;
begin
  //   -   
end;

//""  
procedure TState.Exit;
begin
  //   -   
end;


end.
