//   , 
//     Windows
unit MainWindowUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, CheckLst, StateUnit, AutomataUnit,
  PhotoUnit;

type
  TMainForm = class(TForm)
    ControlPanel: TGroupBox;
    LogPanel: TGroupBox;
    LogMemo: TMemo;
    ViewPanel: TGroupBox;
    ViewImage: TImage;
    Sig1Btn: TSpeedButton;
    Sig2Btn: TSpeedButton;
    Sig3Btn: TSpeedButton;
    Sig4Btn: TSpeedButton;
    Label1: TLabel;
    Bevel1: TBevel;
    Checks: TCheckListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Sig3BtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;  //  
  buffer: TBitmap;      //"" 
  App: TApp;        //  ""
  AppPhoto: TPhoto; // 

const
  //  
  ltSignal            = 0;
  ltEnterExit         = 1;
  ltMoves             = 2;
  ltStateManagement   = 3;
  ltStateChange       = 4;

procedure ProcessSignal(signal: integer);  //  
procedure Log(messageType: integer; messageText: string); // 
  //   

implementation

{$R *.dfm}

//     
procedure TMainForm.FormCreate(Sender: TObject);
var
  i: integer;
begin
  buffer:=TBitmap.Create;
  buffer.Width:=ViewImage.Width;
  buffer.Height:=ViewImage.Height;
  for i := 0 to Checks.Items.Count-1 do
    Checks.Checked[i]:=true;
  //  ""
  App:=TApp.Create;
  //   ""-
  App.RegisterState(TState1.Create(App,70,130));
  App.RegisterState(TState2.Create(App,188,88));
  App.RegisterState(TState3.Create(App,350,140));
  App.RegisterState(TState4.Create(App,250,270));
  App.RegisterState(TState5.Create(App,420,230));      
  // "" 
  AppPhoto:=TPhoto.Create;
  AppPhoto.Left:=App.CurrentAutomataState.Left;
  AppPhoto.Top:=App.CurrentAutomataState.Top;
end;

//   
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  buffer.Free;
  AppPhoto.Free;
  App.Free; // -
end;

//      
procedure UpdateBuffer;
begin
  with buffer do
  begin
    canvas.Pen.Color:=clBlack;
    canvas.Pen.Width:=1;
    canvas.Brush.Color:=clWhite;
    canvas.Rectangle(0,0,width,height);
  end;
end;

//   
procedure UpdateView;
begin
  UpdateBuffer;
  MainForm.ViewImage.Canvas.Draw(0,0,buffer);
end;

//  
procedure ProcessSignal(signal: integer);
begin
  App.ProcessSignal(signal);
end;

//    
procedure TMainForm.Sig3BtnClick(Sender: TObject);
begin
  Log(ltSignal,'  '+
    inttostr((sender as TSpeedButton).Tag));
  ProcessSignal((sender as TSpeedButton).Tag);
end;

//     
procedure Log(messageType: integer; messageText: string);
begin
  if MainForm.Checks.Checked[messageType] then
    MainForm.LogMemo.Lines.Add(timetostr(now)+' '+messageText)
end;

end.
