//   ,  
// "" pp'.
unit PhotoUnit;
interface
uses Graphics, ExtCtrls, Forms, Windows;
type
  TPhoto = class(TObject)
  private
    fX,fY: integer;
    fSmile, fSize: double;
    fColor: TColor;
    appBody: TShape;
    appEyes: array [0..1] of TShape;
    appMouth: TShape;
    procedure setXPos(x: integer);
    procedure setYPos(y: integer);
    procedure setSmile(s: double);
    procedure setColor(c: TColor);
    procedure setSize(s: double);
    procedure Update;
  public
    property Left: integer read fX write setXPos; //X-
    property Top: integer read fY write setYPos;  //Y-
    property Smile: double read fSmile write setSmile;  //""
    property Color: TColor read fColor write setColor;  //
    property Size: double read fSize write setSize;  //
    constructor Create;
    procedure WalkTo(newX, newY: integer);  //   (x,y)
  end;

implementation
uses MainUnit;

procedure TPhoto.setXPos(x: integer);
begin
  fX:=x;
  Update;
end;

procedure TPhoto.setYPos(y: integer);
begin
  fY:=y;
  Update;
end;

procedure TPhoto.setSmile(s: double);
begin
  fSmile:=s;
  Update;
end;

procedure TPhoto.setSize(s: double);
begin
  fSize:=s;
  Update;
end;

procedure TPhoto.setColor(c: TColor);
begin
  fColor:=c;
  Update;
end;

// -""
constructor TPhoto.Create;
var
  i: integer;
begin
  fColor:=clYellow;
  fSize:=0.5;
  fSmile:=0;
  fX:=0;
  fY:=0;
  appBody:=TShape.Create(MainForm);
  appBody.Shape:=stEllipse;
  appBody.Parent:=MainForm.ViewPanel;
  for i := 0 to 1 do
  begin
    appEyes[i]:=TShape.Create(MainForm);
    appEyes[i].Shape:=stEllipse;
    appEyes[i].Parent:=MainForm.ViewPanel;
    appEyes[i].Width:=6;
    appEyes[i].height:=6;
    appEyes[i].Brush.Color:=clBlue;
  end;
  appMouth:=TShape.Create(MainForm);
  appMouth.Shape:=stEllipse;
  appMouth.Parent:=MainForm.ViewPanel;
  appMouth.Brush.Color:=clRed;
  appMouth.Width:=16;

  Update;
end;

//  
procedure TPhoto.Update;
begin
  appBody.Brush.Color:=fColor;
  appBody.Width:=25+round(fSize*25);
  appBody.Height:=25+round(fSize*25);
  appBody.Left:=fX-appBody.Width div 2;
  appBody.Top:=fY-appBody.height div 2;
  appEyes[0].Left:=fX-3-appBody.Width div 5;
  appEyes[0].Top:=fY-appBody.Width div 3;
  appEyes[1].Left:=-3+fX+appBody.Width div 5;
  appEyes[1].Top:=fY-appBody.Width div 3;
  appMouth.Top:=fY+2;//+appBody.Height div 10;
  appMouth.Left:=fX-appMouth.Width div 2;
  appMouth.Height:=4+round(fSmile*8);
end;

//   (x,y)
procedure TPhoto.WalkTo(newX, newY: integer);
var
  i, oldX, oldY: integer;
begin
  MainForm.ControlPanel.Enabled:=false;
  oldX:=fX;
  oldY:=fY;
  for i := 0 to 10 do
  begin
    fX:=oldX+round(i*(newX-oldX)/10);
    fY:=oldY+round(i*(newY-oldY)/10);
    Update;
    Application.ProcessMessages;
    Sleep(90);
  end;
  MainForm.ControlPanel.Enabled:=true;  
end;

end.
